#include "MotorDriver.h"

const int joystick = A5;
const int obstacle = 7;
int o = 0;
int y = 0;
int button;

void setup()
 {
  Serial.begin(9600);
  motordriver.init();
  motordriver.setSpeed(255,MOTORB);
  motordriver.setSpeed(255,MOTORA);
 }


// V -----    MAIN LOOP     -----  V  //
void loop()
{ 
  y = 515; // FAKE INPUT DATA FOR JOYSTICK
  y = readJoystick(); // READ JOYSTICK DATA
  o = readObstacle(); // READ INFRARED OBSTACLE SENSOR DATA
  Serial.print(o); // PRINT IR SENSOR STATUS TO SERIAL
 
  if(o < 1) // IR SENSOR TRIPPED
   { walled(); }
  else
  if(y > 514)
   {
     backward();
     delay(1500);
     left();
     delay(2500); }
  else
  if(y < 511)
    {  backward();
     delay(1500);
   right();
     delay(2500); } 
  else
  { forward();
    Serial.print('\n'); } 
}
//  ^  -----    MAIN LOOP     -----  ^  //


// V FUNCTION DEFINITIONS V //

// VV SENSORY INPUT VV //
  // VV JOYSTICK INPUT VV //
   int readJoystick()
   {
    int joy;                    // Holds Data From Sensor. 
    joy = analogRead(joystick); // Takes Data From Sensor. 
        Serial.print(joy);          // Print sensor Value TO Serial.
    return joy;                 // Return Value Of Sensor.
   }
  // ^^ JOYSTICK INPUT ^^ //
  
  // VV OBSTACLE SENSOR INPUT VV //
   int readObstacle()  
   {
    int obs;                     // Holds Data From Sensor.
    obs = digitalRead(obstacle); // Takes Data From Sensor.
    //    Serial.print(obs);           // Print Value Of Sensor To Serial.
    return obs;                  // Return Value Of Sensor.
   }
  // OBSTACLE SENSOR INPUT //

// ^^ SENSORY INPUT ^^ //


// VV MOVEMENT VV //
 // ---------- FORWARD ---------- //
  void forward()
  {
     motordriver.goForward();
     delay(250);
     Serial.print("Forward");
  }
  // ---------- FORWARD ---------- //

  // ---------- BACKWARD ---------- //
    void backward() 
    {    
     motordriver.goBackward();
    }
  // ---------- BACKWARD ---------- //
 
  // ---------- LEFT ---------- //
    void left()
    {
     motordriver.goLeft();
     Serial.print("left\n");
    }
  // ---------- LEFT ---------- //

 // ---------- RIGHT ---------- //
  void right() 
  {
   motordriver.goRight();
   Serial.print("right\n"); 
  }
 // ---------- RIGHT ---------- //

 
 // ---------- WALLED ---------- //
   void walled() 
   {
    motordriver.stop();
    backward();
    delay(1000);
    motordriver.stop();
    left();
    delay(2500);
    motordriver.stop();
    Serial.print("90deg\n");
   }
  // ---------- Walled ---------- //
   
// ^^ MOVEMENT ^^ //


